//////////////////////////////////////////////////////////// 
//
//   <autogenerated>
//      This code was generated from CDL by a tool.
//
//      In order to preserve your custom code, this source
//      will not be regenerated by the translator unless
//      this existing file is deleted.
//   </autogenerated>
//
//   Template Version:
//
//      CORE v4.0.0 for ANSI C++ v1.0.0 (14/11/2007)
//    
////////////////////////////////////////////////////////////
//#include <math.h> // for rand()

#include <Derived/Infrastructure/Circuitry/MyCircuitCctElem.hpp>
#include <Derived/Infrastructure/Circuitry/MyCircuit_CalcMthdElem.hpp>

// GLOBAL NAMESPACE {
   Float F( Float* Top, Float* Mid, Float* Btm )
   {
      const Uns L = 0;
      const Uns M = 1;
      const Uns R = 2;
      const Float scale = 0.707f;  // 1 / root 2

      Float sum = scale * Top[L] + Top[M] + scale * Top[R] +
                  Mid[L] + /*0.5f * Mid[M] +*/ Mid[R]  +
                  scale * Btm[L] + Btm[M] + scale * Btm[R];

      sum *= 0.14644f;  
      sum -= Mid[M] *0.01f;

      if ( sum > 1.0f )
         sum = 1.0f;

      return sum;
   }

   void Wave( Float* TopOut,   Float* MidOut, Float* BtmOut,
              Float* NxtBtmIn, Float* TopIn,  Float* MidIn, Float* BtmIn, Float* PrvTopIn,
              const Uns GRID, const Uns NROWS )
   {
      Uns r_m1;
      Uns r_0;
      Uns r_p1;
      const Uns c_first = 0;
      const Uns c_last  = GRID - 1;

      // btm strip
      r_p1 = 0;

      if ( PrvTopIn == NULL )
      {
         for ( Uns c = c_first; c <= c_last; ++c )
         {
            BtmOut[c] = MidIn[r_p1+c] * 0.5f;
         }
      }
      else
      {
         BtmOut[c_first] = BtmIn[c_first+1] * 0.5f;
         BtmOut[c_last]  = BtmIn[c_last-1] * 0.5f;

         for ( Uns c = 1; c < c_last; ++c )
         {
            const Uns c_1 = c-1;
            BtmOut[c] = F( &MidIn[r_p1+c_1], &BtmIn[c_1], &PrvTopIn[c_1] );
         }
      }  
   
      // btm of mid band
      r_p1 = GRID;
      r_0  = 0;

      MidOut[r_0+c_first] = MidIn[r_0+c_first+1] * 0.5f;
      MidOut[r_0+c_last]  = MidIn[r_0+c_last-1] * 0.5f;

      for ( Uns c = 1; c < c_last; ++c )
      {
         const Uns c_1 = c-1;
         MidOut[r_0+c] = F( &MidIn[r_p1+c_1], &MidIn[r_0+c_1], &BtmIn[c_1] );
      }

      // mid of mid band
      r_m1 = 0;
      r_0  = GRID;
      r_p1 = r_0 + GRID;

      for ( Uns r = 1; r < NROWS-1; ++r )
      {
         MidOut[r_0+c_first] = MidIn[r_0+c_first+1] * 0.5f;
         MidOut[r_0+c_last]  = MidIn[r_0+c_last-1] * 0.5f;

         for ( Uns c = 1; c < c_last; ++c )
         {
            const Uns c_1 = c-1;
            MidOut[r_0+c] = F( &MidIn[r_p1+c_1], &MidIn[r_0+c_1], &MidIn[r_m1+c_1] );
         }

         r_m1  = r_0;
         r_0   = r_p1;
         r_p1 += GRID;
      } 

      // top of mid band
      MidOut[r_0+c_first] = MidIn[r_0+c_first+1] * 0.5f;
      MidOut[r_0+c_last] = MidIn[r_0+c_last-1] * 0.5f;

      for ( Uns c = 1; c < c_last; ++c )
      {
         const Uns c_1 = c-1;
         MidOut[r_0+c] = F( &TopIn[c_1], &MidIn[r_0+c_1], &MidIn[r_m1+c_1] );
      }

      // top strip
      r_m1 = GRID*(NROWS-1);

      if ( NxtBtmIn == NULL )
      {
         for ( Uns c = c_first; c <= c_last; ++c )
         {
            TopOut[c] = MidIn[r_m1+c] * 0.5f;
         }
      }
      else
      {
         TopOut[c_first] = TopIn[c_first+1] * 0.5f;
         TopOut[c_last]  = TopIn[c_last-1] * 0.5f;

         for ( Uns c = 1; c < c_last; ++c )
         {
            const Uns c_1 = c-1;
            TopOut[c] = F( &NxtBtmIn[c_1], &TopIn[c_1], &MidIn[r_m1 + c_1] );
         }
      }
   } 

   /// <summary>
   /// Default processing overload.
   /// </summary>
   /// <returns>TRUE if successful, FALSE if failed</returns>
   Uns MyCircuit_CalcMthdElem::Process()
   {
      // TODO: Add custom process code

      // make references to input stores
      Float* btmNxtIn = (ElemNum() < NB-1) ? this->Trigger1_StripBottomTst2Rec( 1 ).Data().Values() : NULL; // null if last band
      Float* topIn    = this->Trigger1_StripTopTst2Rec( 0 ).Data().Values();
      Float* midIn    = this->Trigger1_MidBandTst2Rec().Data().Values();
      Float* btmIn    = this->Trigger1_StripBottomTst2Rec( 0 ).Data().Values();
      Float* topPrvIn = (ElemNum() > 0) ? this->Trigger1_StripTopTst2Rec( 1 ).Data().Values() : NULL; // null if first band

      Uns frameNum = 1 + this->Trigger1_MidBandTst2Rec().Data().FrameCount();

      // construct output data
      this->Trigger2_StripTopTst3Rec().Construct( 1 );
      this->Trigger2_StripTopTst3Rec().Data().Initialise( frameNum );

      this->Trigger2_MidBandTst3Rec().Construct( NUM_ROWS );
      this->Trigger2_MidBandTst3Rec().Data().Initialise( frameNum );

      this->Trigger2_StripBottomTst3Rec().Construct( 1 );   
      this->Trigger2_StripBottomTst3Rec().Data().Initialise( frameNum );

      // calculate Wave

      Wave( this->Trigger2_StripTopTst3Rec().Data().Values(),
            this->Trigger2_MidBandTst3Rec().Data().Values(),
            this->Trigger2_StripBottomTst3Rec().Data().Values(),
            btmNxtIn, 
            topIn, 
            midIn, 
            btmIn, 
            topPrvIn,
            GRID_SIZE,
            NUM_ROWS );

      // random inject of next drop
      unsigned int row =  NUM_ROWS * rand() / RAND_MAX;
      unsigned int col = GRID_SIZE * rand() / RAND_MAX;

      this->Trigger2_MidBandTst3Rec().Data().Values()[row*GRID_SIZE+col] = 1.0f * rand() / RAND_MAX;
      
      return TRUE;
   }

// } GLOBAL NAMESPACE
////////////////////////////////////////////////////////////

