//////////////////////////////////////////////////////////// 
//
//   <autogenerated>
//      This code was generated from CDL by a tool.
//
//      In order to preserve your custom code, this source
//      will not be regenerated by the translator unless
//      this existing file is deleted.
//   </autogenerated>
//
//   Template Version:
//
//      CORE v4.0.0 for ANSI C++ v1.0.0 (14/11/2007)
//    
////////////////////////////////////////////////////////////

#include <Derived/Infrastructure/Circuitry/MyCircuitCctElem.hpp>
#include <Derived/Infrastructure/Circuitry/MyCircuit_PixellateMthdElem.hpp>

// GLOBAL NAMESPACE {

   void CalcPixels( Char*& OutArray, Float*& InArray, Uns* ColourMap, 
                    const Uns GRID, const Uns COLOUR_PLANES, const Uns LOOKUP_LEVELS )
   {
      for ( Uns c = 0; c < GRID; ++c )
      {
         // scale in value cast
         Float Value = *InArray * LOOKUP_LEVELS;

         // cast to unsigned int
         Uns Idx = Value > 0.0f ? (Uns) Value : 0;
         if ( Idx >= LOOKUP_LEVELS )
            Idx = LOOKUP_LEVELS - 1;

         // get color from look up table
         memcpy( OutArray, &ColourMap[Idx], COLOUR_PLANES );

         // increament pointers
         ++InArray;
         OutArray  += COLOUR_PLANES;
      }
   }

   /// <summary>
   /// Default processing overload.
   /// </summary>
   /// <returns>TRUE if successful, FALSE if failed</returns>
   Uns MyCircuit_PixellateMthdElem::Process()
   {
      // TODO: Add custom process code

      // construct output and take reference to output
      this->Trigger1_PixelsTst2Rec().Construct();
      Pixels& pixels = this->Trigger1_PixelsTst2Rec().Data();

      // pointer to first location in pixmap - calc functions will increment pointer
      Char*   outArray  = pixels.Values();

      // pointer to first location in in data - clac functions will increment pointer
      Float*   inArray = NULL;

      // pointer to in data
      Band*   band = NULL;

      // get colourMap from Workspace
      Uns* colourMap = this->Workspace().Data().Colours();

      for ( Uns b = 0; b < NB; ++b )
      {
         // bottom strip
         band = this->Trigger2_StripBottomTst2Rec( b ).Struct();
         inArray = band->Values();

         CalcPixels( outArray, inArray, colourMap, GRID_SIZE, NUM_COLOUR_PLANES, NUM_LOOKUP_LEVELS ); 

         // mid beam - repeat for each row
         band = this->Trigger2_MidBandTst2Rec( b ).Struct();
         inArray = band->Values();

         for ( Uns r = 0; r < NUM_ROWS; ++r )
         {
            CalcPixels( outArray, inArray, colourMap, GRID_SIZE, NUM_COLOUR_PLANES, NUM_LOOKUP_LEVELS );
         }

         // top strip
         band = this->Trigger2_StripTopTst2Rec( b ).Struct();
         inArray = band->Values();

         CalcPixels( outArray, inArray, colourMap, GRID_SIZE, NUM_COLOUR_PLANES, NUM_LOOKUP_LEVELS ); 
      }

      // update output frame number - use last band
      pixels.FrameCount() = band->FrameCount();

      return TRUE;
   }

// } GLOBAL NAMESPACE
////////////////////////////////////////////////////////////

