#include "CPixmap.h"

/////////////////////////////////////////////////////////////////////////////
CPixmap::CPixmap(HDC DeviceContextHandle, int Width, int Height )
{
   mDeviceContextHandle = DeviceContextHandle;

   mWidth  = Width;
   mHeight = Height;

   mMemDeviceContextHandle = ::CreateCompatibleDC( DeviceContextHandle );   

   mMemBitmap = ::CreateCompatibleBitmap( DeviceContextHandle,
                                          Width,
                                          Height );

   mPreviousBitmap = (HBITMAP)::SelectObject( mMemDeviceContextHandle,
                                              mMemBitmap );

   mBitmapDataSizeBytes = sizeof( unsigned char* ) * Width * Height * 4;

   mBitmapData = (unsigned char*)malloc( mBitmapDataSizeBytes );   
}

/////////////////////////////////////////////////////////////////////////////
CPixmap::~CPixmap()
{
   if ( mMemBitmap )
   {
      ::SelectObject( mMemDeviceContextHandle, mPreviousBitmap );
      ::DeleteObject( mMemBitmap );
   }
   
   ::DeleteDC( mMemDeviceContextHandle );

   if ( mBitmapData )
   {
      free( mBitmapData );
   }
}

/////////////////////////////////////////////////////////////////////////////
unsigned char* CPixmap::GetBitmapData()
{
   return mBitmapData;
}

/////////////////////////////////////////////////////////////////////////////
void CPixmap::CommitBitmapData()
{
   SetBitmapBits( mMemBitmap,
                  mBitmapDataSizeBytes,
                  mBitmapData );
}

/////////////////////////////////////////////////////////////////////////////
void CPixmap::Update()
{                  
   ::BitBlt( mDeviceContextHandle,
             0, 0, 
             mWidth,
             mHeight,          
             mMemDeviceContextHandle,
             0,
             0,           
             SRCCOPY );
   
   Draw( mDeviceContextHandle );
}

