//////////////////////////////////////////////////////////////////////////////
// 
//    MODULE NAME :     Pixmap Class
// 
//    FILENAME    :     CPixmap.h
// 
//    AUTHORS     :     D. J. Churchill
// 
//    CREATED     :     10/06/2005
// 
//    COPYRIGHT   :     D. J. Churchill  
// 
//    VERSION     :     1.0 
// 
//////////////////////////////////////////////////////////////////////////////
#ifndef C_PIXAMP_H
#define C_PIXMAP_H

#include <windows.h>

class CPixmap
{
public:
   CPixmap( HDC HandleDeviceContext, int Width, int Height );
   virtual ~CPixmap();

   unsigned char* GetBitmapData();
   void           CommitBitmapData();

   void Update();

protected:
   virtual void Draw( HDC Hdc ){;}

private:
   int        mWidth, mHeight;
   HDC        mDeviceContextHandle;
   HDC        mMemDeviceContextHandle;
   HBITMAP    mMemBitmap;
   HBITMAP    mPreviousBitmap;

   unsigned char* mBitmapData;
   unsigned int   mBitmapDataSizeBytes;
};

#endif