#include "CViewerPixmap.h"

/////////////////////////////////////////////////////////////////////////////
CViewerPixmap::CViewerPixmap(HDC DeviceContextHandle, int Width, int Height ) : CPixmap ( DeviceContextHandle, Width, Height )
{
   mWhitePen = ::CreatePen( PS_SOLID, 1, RGB( 255, 255, 255 ) );

   mShowBoundingRect = false;

   mZoomInitialXPos = 0; 
   mZoomInitialYPos = 0;
   mWidth           = Width;
   mHeight          = Height;
}

/////////////////////////////////////////////////////////////////////////////
void CViewerPixmap::Draw( HDC Hdc )
{
}

/////////////////////////////////////////////////////////////////////////////
void CViewerPixmap::SetBoundingRect( int ZoomInitialXPos,
                                     int ZoomInitialYPos,
                                     int Width,
                                     int Height )
{
   mZoomInitialXPos = ZoomInitialXPos;
   mZoomInitialYPos = ZoomInitialYPos;
   mZoomWidth       = Width;
   mZoomHeight      = Height;
}

/////////////////////////////////////////////////////////////////////////////
void CViewerPixmap::ShowBoundingRect( bool Show )
{
   mShowBoundingRect = Show;
}

/////////////////////////////////////////////////////////////////////////////
void CViewerPixmap::MakeGreyScale()
{
   unsigned char* BitmapData = GetBitmapData();
   
   int NumBytes     = mWidth * mHeight * 4;
   int BytesPerLine = mWidth * 4; 
   int NumLines     = NumBytes / BytesPerLine;
   int PixelCount   = BytesPerLine / 4;

   int ByteCount = 0;

   for( int Line = 0; Line < NumLines; Line++ )
   {
      for( int Pixel = 0; Pixel < PixelCount; Pixel++ )
      {
         unsigned char Red   = BitmapData[ByteCount];
         unsigned char Green = BitmapData[ByteCount+1];
         unsigned char Blue  = BitmapData[ByteCount+2];

         unsigned int Average = ( Red + Green + Blue ) / 3;

         BitmapData[ByteCount]   = Average;
         BitmapData[ByteCount+1] = Average;
         BitmapData[ByteCount+2] = Average;

         ByteCount += 4;
      }
   }

   CommitBitmapData();
}