// GUIDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GUI.h"
#include "GUIDlg.h"

#include <ProjectHeader.hpp>
#include <Process1Process_includes.hpp>
#include <GUI/Win32/CPP/Include/Win32_Process.hpp>

/*
#ifdef _DEBUG
#define new DEBUG_NEW
#endif
*/

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CGUIDlg dialog




CGUIDlg::CGUIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGUIDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CGUIDlg::~CGUIDlg()
{
   delete mOutputDlg;
}

void CGUIDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_BUTTON1, StartBtn);
}

BEGIN_MESSAGE_MAP(CGUIDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
   ON_WM_CLOSE()
   ON_BN_CLICKED(IDC_BUTTON1, &CGUIDlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CGUIDlg message handlers

BOOL CGUIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
   Initialise();
   
   ::CLIP::SetCallbackWindow( this->GetSafeHwnd(), this );
   Process1Process* process = new Process1Process();
   process->Startup();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGUIDlg::Initialise()
{
   CRect Rect;
    
   this->SetWindowPos( NULL, 0,0,0,0, SWP_NOSIZE | SWP_NOZORDER | SWP_SHOWWINDOW );
   this->GetClientRect( &Rect );
   this->ClientToScreen( &Rect );

   mOutputDlg = new COutputDialog( this );
   mOutputDlg->Create( IDD_OUTPUT_DIALOG, this );
   mOutputDlg->SetWindowPos( NULL, Rect.right + 5, 0, GRID_SIZE + 6, GRID_SIZE + 32,  SWP_NOZORDER | SWP_SHOWWINDOW );

   mFirstTime = true;
   QueryPerformanceFrequency(&mFrequency);
   mClockPeriodMicroSec = 1000000.0f / (float)mFrequency.QuadPart;
}

LRESULT CGUIDlg::DefWindowProc( UINT message, WPARAM wParam, LPARAM lParam )
{
   /* call clip message pump */
   CLIP::ProcessPumpMessage( message, wParam, lParam );

   /* call window message pump */
   return CDialog::DefWindowProc( message, wParam, lParam );
} 

void CGUIDlg::OnClose()
{
   ClpExit(0);
   CDialog::OnClose();
}

void CGUIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGUIDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGUIDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CGUIDlg::OnBnClickedButton1()
{
   StartIfce* startIfce = ::GetStartIfce();

   if ( startIfce != NULL )
   {
      startIfce->Aux1_StartCsm1Cxn().Signal();
      StartBtn.EnableWindow( false );
   }
}

///////////////////////////////////////////////////////////////////////////////
void CGUIDlg::UpdatePixels( char* Pixmap, unsigned int FrameCount )
{      
   if ( !mFirstTime )
   {
      const Uns TIME_SAMPLE_COUNT = 10;

      LARGE_INTEGER CurrentCount;

      QueryPerformanceCounter(&CurrentCount);
      mTotalTimeTakenMicroSec += ( CurrentCount.QuadPart - mPreviousCount.QuadPart ) * mClockPeriodMicroSec;
      mPreviousCount = CurrentCount;
      ++mTimeSampleCount;
      mTotalFrameCount += ( FrameCount - mPreviousFrameCount );
      mPreviousFrameCount = FrameCount;

         float AverageFrameRate = (float)mTotalFrameCount / ( mTotalTimeTakenMicroSec * 0.000001f );

         CString Text;
         Text.Format( " FPS = %.1f", AverageFrameRate );
         SetWindowText( Text );

      if ( mTimeSampleCount == TIME_SAMPLE_COUNT )
      {                
         mTotalTimeTakenMicroSec = 0.0f; 
         mTimeSampleCount = 0;
         mTotalFrameCount = 0;
      }
   }
   else
   {
      mFirstTime = false;
      QueryPerformanceCounter(&mPreviousCount);
      mPreviousFrameCount = FrameCount;
      mTotalTimeTakenMicroSec = 0.0f;
      mTimeSampleCount = 0;
      mTotalFrameCount = 0;
   }

   memcpy( mOutputDlg->GetPixelData(), Pixmap, mOutputDlg->GetPixmapSize() );

   mOutputDlg->UpdatePixelData();
   mOutputDlg->PostMessage( WM_PAINT );
}
// *********************************************************** 

void UpdateDisplay( void* Dlg, char* Pixmap, unsigned int FrameCount )
{
   // update pixmap

   ((CGUIDlg*) Dlg)->UpdatePixels( Pixmap, FrameCount );
}
