// OutputDialog.cpp : implementation file
//

#include "stdafx.h"
#include "GUI.h"
#include "OutputDialog.h"
#include <ProjectHeader.hpp>

///////////////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNAMIC(COutputDialog, CDialog)

COutputDialog::COutputDialog(CWnd* pParent /*=NULL*/)
	: CDialog(COutputDialog::IDD, pParent)
{
   mFirstTime = true;

   QueryPerformanceFrequency(&mFrequency);

   mClockPeriodMicroSec = 1000000.0f / (float)mFrequency.QuadPart;
}

///////////////////////////////////////////////////////////////////////////////
COutputDialog::~COutputDialog()
{
}

///////////////////////////////////////////////////////////////////////////////
void COutputDialog::OnClose()
{
   ClpExit(0);
   CDialog::OnClose();
}

///////////////////////////////////////////////////////////////////////////////
BOOL COutputDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

   Initialise();

   return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
void COutputDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

///////////////////////////////////////////////////////////////////////////////
BEGIN_MESSAGE_MAP(COutputDialog, CDialog)
   ON_WM_CLOSE()
   ON_WM_PAINT()
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////
void COutputDialog::Initialise()
{
   mViewerPixmap = new CViewerPixmap( this->GetDC()->GetSafeHdc(), GRID_SIZE, GRID_SIZE );

}

unsigned int   COutputDialog::GetPixmapSize()
{
   return GRID_SIZE*GRID_SIZE*NUM_COLOUR_PLANES; 
}

/////////////////////////////////////////////////////////////////////////////
void COutputDialog::OnPaint()
{
   if ( !mFirstTime )
   {
      LARGE_INTEGER CurrentCount;

      QueryPerformanceCounter(&CurrentCount);
    
      float TimeTakenMicroSec = ( CurrentCount.QuadPart - mPreviousCount.QuadPart ) * mClockPeriodMicroSec;
      
      mPreviousCount = CurrentCount;
              
      float AverageFrameRate = 1.0f / ( TimeTakenMicroSec * 0.000001f );

      CString Text;

      Text.Format( " FPS = %.1f", AverageFrameRate );

      SetWindowText( Text ); 
   }
   else
   {
      mFirstTime = false;

      QueryPerformanceCounter(&mPreviousCount);
   }

   mViewerPixmap->Update(); 	

   CDialog::OnPaint();
}
